####kalanoro = Dolomedes kalanoro
####sp2 / MADsp2 = Dolomedes bedjanic
####kalanorosp2 / MADsp4 = Dolomedes gregoric
####sp3_Marojejy / MADsp3_Marojejy = Dolomedes hydatostella
####sp3_Vakona / MADsp3_Vakona = Dolomedes rotundus

####Change to your file directory first

library("geomorph")
library('plotrix')
pch_all = c(1,2,4,0,15)
pch_L = c(1,2,4)
pch_S = c(0,15)
mat1 = matrix(c(6,1,1,1,7,1,1,1,8,1,1,1,2,3,4,5), nrow=4,ncol=4,byrow = TRUE)

#####Somatic morphology#####
MadaDolo = read.csv("E:/study_PhD/Projects/Madagascar Dolomedes/landmark/Measurement.csv", header=T)

Dk = MadaDolo[MadaDolo$Species=='Dolomedes kalanoro',]
Dsp4 = MadaDolo[MadaDolo$Species=='Dolomedes MADsp4',]
Dsp2 = MadaDolo[MadaDolo$Species=='Dolomedes MADsp2',]
Dsp3M = MadaDolo[MadaDolo$Species=='Dolomedes MADsp3_Marojejy',]
Dsp3V = MadaDolo[MadaDolo$Species=='Dolomedes MADsp3_Vakona',]

d=rbind(Dk,Dsp4,Dsp2,Dsp3M,Dsp3V)
d$Species = factor(d$Species , levels=c("Dolomedes kalanoro", "Dolomedes MADsp4", "Dolomedes MADsp2", "Dolomedes MADsp3_Marojejy","Dolomedes MADsp3_Vakona"))
df=d[d$Sex=='F',]
dm=d[d$Sex=='M',]

names(pch_all) = levels(d$Species)
pch_simple_F = pch_all[match(df$Species, names(pch_all))]
pch_simple_M = pch_all[match(dm$Species, names(pch_all))]

#Carapace width
CW_F = aov(CW~Species,data=df)
summary(CW_F)
TukeyHSD(CW_F)

CW_M = aov(CW~Species,data=dm)
summary(CW_M)
TukeyHSD(CW_M)

layout(matrix(c(1,2),nrow=1,ncol=2,byrow = FALSE))
par(mar = c(3.5,4,2,0))
boxplot(CW~Species,data=df,col=NULL,lwd = 2, las = 1, xlab = c(''), ylim=c(5,11), lty=1,
        ylab = c('Carapace width (mm)'), cex = 1.2, cex.lab = 1.25, cex.axis = 1.2, xaxt = 'n',main = c('Female'))
abline(h=7,lwd=2,lty=2,col='gray60')
text(5.45,7.15,labels=c('7mm'),cex=0.8,font=2,col='gray60')
text(c(1:5), c(10.6,8.1,10.85,6.85,6.65),xpd=NA,labels = c('n=4','n=3','n=14','n=5','n=3'))
Axis(side=1, at = c(1:5), labels = FALSE)
text(c(1:5), c(rep(4.3,5)),xpd=NA,labels = c('kalanoro','gregoric','bedjanic','hydatostella','rotundus'),
     font=4,srt=-20)
par(mar = c(3.5,1.5,2,2.5))
boxplot(CW~Species,data=dm,col=NULL,lwd = 2, las = 1, xlab = c(''), ylab = NULL, lty=1,
        ylim=c(5,11), cex = 1.2, cex.lab = 1.25, cex.axis = 1.2, xaxt = 'n', yaxt = 'n',
        main = c('Male'))
abline(h=6.5,lwd=2,lty=2,col='gray60')
text(5.4,6.65,labels=c('6.5mm'),cex=0.8,font=2,col='gray60')
text(c(1:5), c(8.95,7.55,8.3,6.35,6.15),xpd=NA,labels = c('n=5','n=2','n=7','n=2','n=6'))
Axis(side=1, at = c(1:5), labels = FALSE)
text(c(1:5), c(rep(4.3,5)),xpd=NA,labels = c('kalanoro','gregoric','bedjanic','hydatostella','rotundus'),
     font=4,srt=-20)

#Leg I/carapace width
L1.CW.F = df$Leg.I/df$CW
L1_CW_F = aov(L1.CW.F~Species, data=df)
summary(L1_CW_F)
TukeyHSD(L1_CW_F)

L1.CW.M = dm$Leg.I/dm$CW
L1_CW_M = aov(L1.CW.M~Species, data=dm)
summary(L1_CW_M)
TukeyHSD(L1_CW_M)

layout(matrix(c(1,2),nrow=1,ncol=2,byrow = FALSE))
par(mar = c(3.5,4,2,0))
boxplot(L1.CW.F~Species,data=df,col=NULL,lwd = 2, las = 1, xlab = c(''), lty=1, ylim=c(3.5,6.6),
        ylab = c('Leg I length / Carapace width'), cex = 1.2, cex.lab = 1.25, cex.axis = 1.2, xaxt = 'n',main = c('Female'))
text(c(1:5), c(5.05,5.35,5.5,3.85,3.75),xpd=NA,labels = c('n=4','n=3','n=14','n=5','n=3'))
Axis(side=1, at = c(1:5), labels = FALSE)
text(c(1:5), c(rep(3.1,5)),xpd=NA,labels = c('kalanoro','gregoric','bedjanic','hydatostella','rotundus'),
     font=4,srt=-20)
par(mar = c(3.5,1.5,2,2.5))
boxplot(L1.CW.M~Species,data=dm,col=NULL,lwd = 2, las = 1, xlab = c(''), ylab = NULL, lty=1, ylim = c(3.5,6.6),
        cex = 1.2, cex.lab = 1.25, cex.axis = 1.2, xaxt = 'n', yaxt = 'n', main = c('Male'))
text(c(1:5), c(6.3,6.55,6.5,4.7,5.3),xpd=NA,labels = c('n=5','n=2','n=7','n=2','n=6'))
Axis(side=1, at = c(1:5), labels = FALSE)
text(c(1:5), c(rep(3.1,5)),xpd=NA,labels = c('kalanoro','gregoric','bedjanic','hydatostella','rotundus'),
     font=4,srt=-20)

#Tarsus I/leg I length
TL1.F = df$Tarsus.I/df$Leg.I
TL1_F = aov(TL1.F~Species, data=df)
summary(TL1_F)
TukeyHSD(TL1_F)

TL1.M = dm$Tarsus.I/dm$Leg.I
TL1_M = aov(TL1.M~Species, data=dm)
summary(TL1_M)
TukeyHSD(TL1_M)

layout(matrix(c(1,2),nrow=1,ncol=2,byrow = FALSE))
par(mar = c(3.5,4,2,0))
boxplot(TL1.F~Species,data=df,col=NULL,lwd = 2, xlab = c(''), lty=1, ylim = c(0.09, 0.155),
        ylab = c('Tarsus I length / Leg I length'), cex = 1.2, cex.lab = 1.25, xaxt = 'n',main = c('Female'))
text(c(1:5), c(0.126,0.129,0.128,0.104,0.107),xpd=NA,labels = c('n=4','n=3','n=14','n=5','n=3'))
Axis(side=1, at = c(1:5), labels = FALSE)
text(c(1:5), c(rep(0.082,5)),xpd=NA,labels = c('kalanoro','gregoric','bedjanic','hydatostella','rotundus'),
     font=4,srt=-20)
par(mar = c(3.5,1.5,2,2.5))
boxplot(TL1.M~Species,data=dm,col=NULL,lwd = 2, xlab = c(''), ylab = NULL, lty=1, ylim = c(0.09, 0.155),
        cex = 1.2, cex.lab = 1.25, cex.axis = 1.2, xaxt = 'n',  yaxt = 'n', main = c('Male'))
text(c(1:5), c(0.15,0.154,0.152,0.129,0.133),xpd=NA,labels = c('n=5','n=2','n=7','n=2','n=6'))
Axis(side=1, at = c(1:5), labels = FALSE)
text(c(1:5), c(rep(0.082,5)),xpd=NA,labels = c('kalanoro','gregoric','bedjanic','hydatostella','rotundus'),
     font=4,srt=-20)

#Palp/carapace width
P.CW.F = df$Palp/df$CW
P_CW_F = aov(P.CW.F~Species, data=df)
summary(P_CW_F)
TukeyHSD(P_CW_F)

P.CW.M = dm$Palp/dm$CW
P_CW_M = aov(P.CW.M~Species, data=dm)
summary(P_CW_M)
TukeyHSD(P_CW_M)

layout(matrix(c(1,2),nrow=1,ncol=2,byrow = FALSE))
par(mar = c(3.5,4,2,0))
boxplot(P.CW.F~Species,data=df,col=NULL,lwd = 2, las = 1, xlab = c(''), lty=1, ylim = c(1.35,2.2),
        ylab = c('Palp length / Carapace width'), cex = 1.2, cex.lab = 1.25, cex.axis = 1.2, xaxt = 'n',main = c('Female'))
text(c(1:5), c(1.7,1.75,1.8,1.5,1.44),xpd=NA,labels = c('n=4','n=3','n=14','n=5','n=3'))
Axis(side=1, at = c(1:5), labels = FALSE)
text(c(1:5), c(rep(1.25,5)),xpd=NA,labels = c('kalanoro','gregoric','bedjanic','hydatostella','rotundus'),
     font=4,srt=-20)
par(mar = c(3.5,1.5,2,2.5))
boxplot(P.CW.M~Species,data=dm,col=NULL,lwd = 2, las = 1, xlab = c(''), ylab = NULL, lty=1, ylim = c(1.35,2.2),
        cex = 1.2, cex.lab = 1.25, cex.axis = 1.2, xaxt = 'n', yaxt = 'n', main = c('Male'))
text(c(1:5), c(2.02,2.04,2.2,1.65,1.87),xpd=NA,labels = c('n=5','n=2','n=7','n=2','n=6'))
abline(h=2,lwd=2,lty=2,col='gray60')
text(4.3,1.98,labels=c('Palp length = 2 × Carapace width'),cex=0.8,font=2,col='gray60')
Axis(side=1, at = c(1:5), labels = FALSE)
text(c(1:5), c(rep(1.25,5)),xpd=NA,labels = c('kalanoro','gregoric','bedjanic','hydatostella','rotundus'),
     font=4,srt=-20)

#####Male genital measurement#####
#Embolic ring diameter
MadaDolo_E = read.csv("E:/study_PhD/Projects/Madagascar Dolomedes/landmark/Measure_Embolus.csv", header=T)
Ebd = MadaDolo_E[-23,]

E.aov = aov(mm~Species, data=Ebd)
summary(E.aov)
TukeyHSD(E.aov)

E.kw = kruskal.test(mm~Species, data=Ebd)
E.kw
pairwise.wilcox.test(Ebd$mm, Ebd$Species, exact = FALSE, p.adjust.method = 'none')

par(mar = c(3.5,4,2,1))
boxplot(mm~Species, data=Ebd, col=NULL,lwd = 1.5, las = 1, xlab = c(''), lty=1, ylim=c(0.55,1.45),
        ylab = c('Embolic ring diameter (mm)'), cex = 1.2, cex.lab = 1.25, cex.axis = 1.2, xaxt = 'n')
text(c(1:5), c(1.4,1.13,1.02,0.6,0.63),xpd=NA,labels = c('n=5','n=2','n=7','n=2','n=6'))
Axis(side=1, at = c(1:5), labels = FALSE)
text(c(1:5), c(rep(0.44,5)),xpd=NA,labels = c('kalanoro','gregoric','bedjanic','hydatostella','rotundus'),
     font=4,srt=-20)

#Cymbium/Tibia
Cy.Pt = dm$Tp.Cy/dm$Tibia.p
Cy_Pt = aov(Cy.Pt~Species, data=dm)
summary(Cy_Pt)
TukeyHSD(Cy_Pt)

par(mar = c(3.5,4,2,1))
boxplot(Cy.Pt~Species,data=dm,col=NULL,lwd = 2, las = 1, xlab = c(''), lty=1,
        ylab = c('Cymbium length / Palp tibia length'), cex = 1.2, cex.lab = 1.25, cex.axis = 1.2, ylim = c(0.9,1.4), 
        xaxt = 'n')
abline(h=1,lwd=2,lty=2,col='gray60')
text(4.45,1.015,labels=c('Cymbium length = Tibia length'),cex=0.8,font=2,col='gray60')
text(c(1:5), c(1.37,1.19,0.99,1.33,1.24),xpd=NA,labels = c('n=5','n=2','n=7','n=2','n=6'))
Axis(side=1, at = c(1:5), labels = FALSE)
text(c(1:5), c(rep(0.84,5)),xpd=NA,labels = c('kalanoro','gregoric','bedjanic','hydatostella','rotundus'),
     font=4,srt=-20)

#####Female epigynal margin#####
MadaDolo_EpVO = read.csv("E:/study_PhD/Projects/Madagascar Dolomedes/landmark/Epigynum_ventral_outer.csv", header=T)
MadaDolo_EpVO_L = MadaDolo_EpVO[-c(400:551),]
MadaDolo_EpVO_S = MadaDolo_EpVO[-c(1:399),]
link_EpVO = matrix(data=c(1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13,14,14,15,15,16,16,17,17,18,18,19,19,1),
                   nrow=19,ncol=2,byrow = TRUE)
Species_EpVO_L = as.factor(c(rep("kalanoro",length(MadaDolo_EpVO[MadaDolo_EpVO$Species=="kalanoro",]$Species)/19),
                             rep("kalanorosp2",length(MadaDolo_EpVO[MadaDolo_EpVO$Species=="kalanorosp2",]$Species)/19),
                             rep("sp2",length(MadaDolo_EpVO[MadaDolo_EpVO$Species=="sp2",]$Species)/19)))

Species_EpVO_S = as.factor(c(rep("sp3_Marojejy",length(MadaDolo_EpVO[MadaDolo_EpVO$Species=="sp3_Marojejy",]$Species)/19),
                             rep("sp3_Vakona",length(MadaDolo_EpVO[MadaDolo_EpVO$Species=="sp3_Vakona",]$Species)/19)))

EpVO_L = as.matrix(cbind(X=MadaDolo_EpVO_L[,5], Y=MadaDolo_EpVO_L[,6])) %>% arrayspecs(.,19,2)
EpVO_S = as.matrix(cbind(X=MadaDolo_EpVO_S[,5], Y=MadaDolo_EpVO_S[,6])) %>% arrayspecs(.,19,2)

names(pch_L) = levels(Species_EpVO_L)
names(pch_S) = levels(Species_EpVO_S)
pch.gp_EpVO_L = pch_L[match(Species_EpVO_L, names(pch_L))]
pch.gp_EpVO_S = pch_S[match(Species_EpVO_S, names(pch_S))]

EpVO_gpa_L = gpagen(EpVO_L) %>% rotate.coords(. ,type=c("flipY"))
#plot(EpVO_gpa_L)
ref_EpVO_L = mshape(EpVO_gpa_L$coords)
EpVO_gpa_S = gpagen(EpVO_S) %>% rotate.coords(. ,type=c("flipY"))
#plot(EpVO_gpa_S)
ref_EpVO_S = mshape(EpVO_gpa_S$coords)

PCA_EpVO_L = gm.prcomp(EpVO_gpa_L$coords)
summary(PCA_EpVO_L)
PCA_EpVO_S = gm.prcomp(EpVO_gpa_S$coords)
summary(PCA_EpVO_S)

layout(mat1, widths=c(2,2,1,2), heights=c(2,1,2,2))
par(mar = c(4.5,4.5,1,1))
plot(PCA_EpVO_L, type='n', las=1, cex.lab=2, xlab="PC1(40.47%)",ylab="PC2(14.00%)")
points(PCA_EpVO_L$x[,1], PCA_EpVO_L$x[,2], pch = pch.gp_EpVO_L, cex=3,lwd=3)
legend('bottomleft',pt.cex=1.5, pt.lwd=3, cex=1.5, pch=c(1,2,4),legend = c('kalanoro','gregoric','bedjanic'),
       bty='n',text.font=4)
plot(0,type='n',axes=FALSE,ann=FALSE)
m_EpVO_L = mshape(EpVO_gpa_L$coords)
par(mar = c(0,0,0,0))
plotRefToTarget(m_EpVO_L, PCA_EpVO_L$shapes$shapes.comp1$min,mag=1,method = c("vector"),links = link_EpVO)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_EpVO_L, PCA_EpVO_L$shapes$shapes.comp1$max,mag=1,method = c("vector"),links = link_EpVO)
plotRefToTarget(m_EpVO_L, PCA_EpVO_L$shapes$shapes.comp2$max,mag=1,method = c("vector"),links = link_EpVO)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_EpVO_L, PCA_EpVO_L$shapes$shapes.comp2$min,mag=1,method = c("vector"),links = link_EpVO)

par(mar = c(4.5,4.5,1,1))
plot(PCA_EpVO_S, type='n', las=1, cex.lab=2, ylim=c(-0.06,0.08), xlab="PC1(34.29%)",ylab="PC2(24.70%)")
points(PCA_EpVO_S$x[,1], PCA_EpVO_S$x[,2], pch = pch.gp_EpVO_S, cex=3,lwd=3)
legend('topright',pt.cex=1.5, pt.lwd=3, cex=1.5, pch=c(0,15),legend = c('hydatostella','rotundus'),
       bty='n',text.font=4)
plot(0,type='n',axes=FALSE,ann=FALSE)
m_EpVO_S = mshape(EpVO_gpa_S$coords)
par(mar = c(0,0,0,0))
plotRefToTarget(m_EpVO_S, PCA_EpVO_S$shapes$shapes.comp1$min,mag=1,method = c("vector"),links = link_EpVO)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_EpVO_S, PCA_EpVO_S$shapes$shapes.comp1$max,mag=1,method = c("vector"),links = link_EpVO)
plotRefToTarget(m_EpVO_S, PCA_EpVO_S$shapes$shapes.comp2$max,mag=1,method = c("vector"),links = link_EpVO)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_EpVO_S, PCA_EpVO_S$shapes$shapes.comp2$min,mag=1,method = c("vector"),links = link_EpVO)

#####Female epigynal middle field#####
MadaDolo_EpVM = read.csv("E:/study_PhD/Projects/Madagascar Dolomedes/landmark/Epigynum_ventral_middle.csv", header=T)
MadaDolo_EpVM_L = MadaDolo_EpVM[-c(400:551),]
MadaDolo_EpVM_S = MadaDolo_EpVM[-c(1:399),]
link_EpVM = matrix(data=c(1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 2,
                          8, 9, 9, 10,10,11,11,12,12,13,13,14,14,9,
                          4, 15,15,16,16,17,17,18,18,11,
                          5, 19,19,12),nrow=21,ncol=2,byrow = TRUE)
Species_EpVM_L = as.factor(c(rep("kalanoro",length(MadaDolo_EpVM[MadaDolo_EpVM$Species=="kalanoro",]$Species)/19),
                             rep("kalanorosp2",length(MadaDolo_EpVM[MadaDolo_EpVM$Species=="kalanorosp2",]$Species)/19),
                             rep("sp2",length(MadaDolo_EpVM[MadaDolo_EpVM$Species=="sp2",]$Species)/19)))
                           
Species_EpVM_S = as.factor(c(rep("sp3_Marojejy",length(MadaDolo_EpVM[MadaDolo_EpVM$Species=="sp3_Marojejy",]$Species)/19),
                             rep("sp3_Vakona",length(MadaDolo_EpVM[MadaDolo_EpVM$Species=="sp3_Vakona",]$Species)/19)))

EpVM_L = as.matrix(cbind(X=MadaDolo_EpVM_L[,5], Y=MadaDolo_EpVM_L[,6])) %>% arrayspecs(.,19,2)
EpVM_S = as.matrix(cbind(X=MadaDolo_EpVM_S[,5], Y=MadaDolo_EpVM_S[,6])) %>% arrayspecs(.,19,2)

names(pch_L) = levels(Species_EpVM_L)
names(pch_S) = levels(Species_EpVM_S)
pch.gp_EpVM_L = pch_L[match(Species_EpVM_L, names(pch_L))]
pch.gp_EpVM_S = pch_S[match(Species_EpVM_S, names(pch_S))]

EpVM_gpa_L = gpagen(EpVM_L) %>% rotate.coords(. ,type=c("rotateC"))
#plot(EpVM_gpa_L)
ref_EpVM_L = mshape(EpVM_gpa_L$coords)
EpVM_gpa_S = gpagen(EpVM_S) %>% rotate.coords(. ,type=c("flipX")) %>% rotate.coords(. ,type=c("flipY"))
#plot(EpVM_gpa_S)
ref_EpVM_S = mshape(EpVM_gpa_S$coords)

PCA_EpVM_L = gm.prcomp(EpVM_gpa_L$coords)
summary(PCA_EpVM_L)
PCA_EpVM_S = gm.prcomp(EpVM_gpa_S$coords)
summary(PCA_EpVM_S)

layout(mat1, widths=c(2,2,1,2), heights=c(2,1,2,2))
par(mar = c(4.5,4.5,1,1))
plot(PCA_EpVM_L, type='n', las=1, cex.lab=2, xlab="PC1(53.11%)",ylab="PC2(18.74%)")
points(PCA_EpVM_L$x[,1], PCA_EpVM_L$x[,2], pch = pch.gp_EpVM_L, cex=3,lwd=3)
legend('topleft',pt.cex=1.5, pt.lwd=3, cex=1.5, pch=c(1,2,4),legend = c('kalanoro','gregoric','bedjanic'),
       bty='n',text.font=4)
plot(0,type='n',axes=FALSE,ann=FALSE)
m_EpVM_L = mshape(EpVM_gpa_L$coords)
par(mar = c(0,0,0,0))
plotRefToTarget(m_EpVM_L, PCA_EpVM_L$shapes$shapes.comp1$min,mag=1,method = c("vector"),links = link_EpVM)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_EpVM_L, PCA_EpVM_L$shapes$shapes.comp1$max,mag=1,method = c("vector"),links = link_EpVM)
plotRefToTarget(m_EpVM_L, PCA_EpVM_L$shapes$shapes.comp2$max,mag=1,method = c("vector"),links = link_EpVM)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_EpVM_L, PCA_EpVM_L$shapes$shapes.comp2$min,mag=1,method = c("vector"),links = link_EpVM)

par(mar = c(4.5,4.5,1,1))
plot(PCA_EpVM_S, type='n', las=1, cex.lab=2, xlab="PC1(64.85%)",ylab="PC2(17.64%)")
points(PCA_EpVM_S$x[,1], PCA_EpVM_S$x[,2], pch = pch.gp_EpVM_S, cex=3,lwd=3)
legend('topleft',pt.cex=1.5, pt.lwd=3, cex=1.5, pch=c(0,15),legend = c('hydatostella','rotundus'),
       bty='n',text.font=4)
plot(0,type='n',axes=FALSE,ann=FALSE)
m_EpVM_S = mshape(EpVM_gpa_S$coords)
par(mar = c(0,0,0,0))
plotRefToTarget(m_EpVM_S, PCA_EpVM_S$shapes$shapes.comp1$min,mag=1,method = c("vector"),links = link_EpVM)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_EpVM_S, PCA_EpVM_S$shapes$shapes.comp1$max,mag=1,method = c("vector"),links = link_EpVM)
plotRefToTarget(m_EpVM_S, PCA_EpVM_S$shapes$shapes.comp2$max,mag=1,method = c("vector"),links = link_EpVM)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_EpVM_S, PCA_EpVM_S$shapes$shapes.comp2$min,mag=1,method = c("vector"),links = link_EpVM)

#####Female vulva#####
MadaDolo_EpD = read.csv("E:/study_PhD/Projects/Madagascar Dolomedes/landmark/Epigynum_dorsal.csv", header=T)
MadaDolo_EpD_L = MadaDolo_EpD[-c(161:224),]
MadaDolo_EpD_S = MadaDolo_EpD[-c(1:160),]
link_EpD = matrix(data=c(1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8),nrow=7,ncol=2,byrow = TRUE)
Species_EpD_L = as.factor(c(rep("kalanoro",length(MadaDolo_EpD[MadaDolo_EpD$Species=="kalanoro",]$Species)/8),
                             rep("kalanorosp2",length(MadaDolo_EpD[MadaDolo_EpD$Species=="kalanorosp2",]$Species)/8),
                             rep("sp2",length(MadaDolo_EpD[MadaDolo_EpD$Species=="sp2",]$Species)/8)))

Species_EpD_S = as.factor(c(rep("sp3_Marojejy",length(MadaDolo_EpD[MadaDolo_EpD$Species=="sp3_Marojejy",]$Species)/8),
                             rep("sp3_Vakona",length(MadaDolo_EpD[MadaDolo_EpD$Species=="sp3_Vakona",]$Species)/8)))

EpD_L = as.matrix(cbind(X=MadaDolo_EpD_L[,5], Y=MadaDolo_EpD_L[,6])) %>% arrayspecs(.,8,2)
EpD_S = as.matrix(cbind(X=MadaDolo_EpD_S[,5], Y=MadaDolo_EpD_S[,6])) %>% arrayspecs(.,8,2)

names(pch_L) = levels(Species_EpD_L)
names(pch_S) = levels(Species_EpD_S)
pch.gp_EpD_L = pch_L[match(Species_EpD_L, names(pch_L))]
pch.gp_EpD_S = pch_S[match(Species_EpD_S, names(pch_S))]

EpD_gpa_L = gpagen(EpD_L) %>% rotate.coords(. ,type=c("flipX")) %>% rotate.coords(. ,type=c("rotateC"))
#plot(EpD_gpa_L,links=link_EpD)
ref_EpD_L = mshape(EpD_gpa_L$coords)
EpD_gpa_S = gpagen(EpD_S) %>% rotate.coords(. ,type=c("flipX")) %>% rotate.coords(. ,type=c("rotateC"))
#plot(EpD_gpa_S,links=link_EpD)
ref_EpD_S = mshape(EpD_gpa_S$coords)

PCA_EpD_L = gm.prcomp(EpD_gpa_L$coords)
summary(PCA_EpD_L)
PCA_EpD_S = gm.prcomp(EpD_gpa_S$coords)
summary(PCA_EpD_S)

layout(mat1, widths=c(2,2,1,2), heights=c(2,1,2,2))
par(mar = c(4.5,4.5,1,1))
plot(PCA_EpD_L, type='n', las=1, cex.lab=2, xlab="PC1(79.61%)",ylab="PC2(7.15%)")
points(PCA_EpD_L$x[,1], PCA_EpD_L$x[,2], pch = pch.gp_EpD_L, cex=3,lwd=3)
legend('bottomright',pt.cex=1.5, pt.lwd=3, cex=1.5, pch=c(1,2,4),legend = c('kalanoro','gregoric','bedjanic'),
       bty='n',text.font=4)
plot(0,type='n',axes=FALSE,ann=FALSE)
m_EpD_L = mshape(EpD_gpa_L$coords)
par(mar = c(0,0,0,0))
plotRefToTarget(m_EpD_L, PCA_EpD_L$shapes$shapes.comp1$min,mag=1,method = c("vector"),links = link_EpD)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_EpD_L, PCA_EpD_L$shapes$shapes.comp1$max,mag=1,method = c("vector"),links = link_EpD)
plotRefToTarget(m_EpD_L, PCA_EpD_L$shapes$shapes.comp2$max,mag=1,method = c("vector"),links = link_EpD)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_EpD_L, PCA_EpD_L$shapes$shapes.comp2$min,mag=1,method = c("vector"),links = link_EpD)

par(mar = c(4.5,4.5,1,1))
plot(PCA_EpD_S, type='n', las=1, cex.lab=2, xlab="PC1(61.21%)",ylab="PC2(19.59%)")
points(PCA_EpD_S$x[,1], PCA_EpD_S$x[,2], pch = pch.gp_EpD_S, cex=3,lwd=3)
legend('bottomright',pt.cex=1.5, pt.lwd=3, cex=1.5, pch=c(0,15),legend = c('hydatostella','rotundus'),
       bty='n',text.font=4)
plot(0,type='n',axes=FALSE,ann=FALSE)
m_EpD_S = mshape(EpD_gpa_S$coords)
par(mar = c(0,0,0,0))
plotRefToTarget(m_EpD_S, PCA_EpD_S$shapes$shapes.comp1$min,mag=1,method = c("vector"),links = link_EpD)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_EpD_S, PCA_EpD_S$shapes$shapes.comp1$max,mag=1,method = c("vector"),links = link_EpD)
plotRefToTarget(m_EpD_S, PCA_EpD_S$shapes$shapes.comp2$max,mag=1,method = c("vector"),links = link_EpD)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_EpD_S, PCA_EpD_S$shapes$shapes.comp2$min,mag=1,method = c("vector"),links = link_EpD)

#####Male palp median apophysis#####
MadaDolo_PVM = read.csv("E:/study_PhD/Projects/Madagascar Dolomedes/landmark/Palp_Ventral_MA.csv", header=T)
MadaDolo_PVM_L = MadaDolo_PVM[-c(253:396),]
MadaDolo_PVM_S = MadaDolo_PVM[-c(1:252),]
link_PVM = matrix(data=c(1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9, 10,
                         10, 11, 11, 12, 12, 13, 13, 14, 14, 15, 15, 16, 16, 17,
                         17, 18, 18, 1),nrow=18,ncol=2,byrow = TRUE)
Species_PVM_L = as.factor(c(rep("kalanoro",length(MadaDolo_PVM[MadaDolo_PVM$Species=="kalanoro",]$Species)/18),
                            rep("kalanorosp2",length(MadaDolo_PVM[MadaDolo_PVM$Species=="kalanorosp2",]$Species)/18),
                            rep("sp2",length(MadaDolo_PVM[MadaDolo_PVM$Species=="sp2",]$Species)/18)))

Species_PVM_S = as.factor(c(rep("sp3_Marojejy",length(MadaDolo_PVM[MadaDolo_PVM$Species=="sp3_Marojejy",]$Species)/18),
                            rep("sp3_Vakona",length(MadaDolo_PVM[MadaDolo_PVM$Species=="sp3_Vakona",]$Species)/18)))

PVM_L = as.matrix(cbind(X=MadaDolo_PVM_L[,5], Y=MadaDolo_PVM_L[,6])) %>% arrayspecs(.,18,2)
PVM_S = as.matrix(cbind(X=MadaDolo_PVM_S[,5], Y=MadaDolo_PVM_S[,6])) %>% arrayspecs(.,18,2)

names(pch_L) = levels(Species_PVM_L)
names(pch_S) = levels(Species_PVM_S)
pch.gp_PVM_L = pch_L[match(Species_PVM_L, names(pch_L))]
pch.gp_PVM_S = pch_S[match(Species_PVM_S, names(pch_S))]

PVM_gpa_L = gpagen(PVM_L) %>% rotate.coords(. ,type=c("flipX")) %>% rotate.coords(. ,type=c("rotateCC"))
#plot(PVM_gpa_L,links=link_PVM)
ref_PVM_L = mshape(PVM_gpa_L$coords)
PVM_gpa_S = gpagen(PVM_S) %>% rotate.coords(. ,type=c("flipX")) %>% rotate.coords(. ,type=c("rotateCC"))
#plot(PVM_gpa_S,links=link_PVM)
ref_PVM_S = mshape(PVM_gpa_S$coords)

PCA_PVM_L = gm.prcomp(PVM_gpa_L$coords)
summary(PCA_PVM_L)
PCA_PVM_S = gm.prcomp(PVM_gpa_S$coords)
summary(PCA_PVM_S)

layout(mat1, widths=c(2,2,1,2), heights=c(2,1,2,2))
par(mar = c(4.5,4.5,1,1))
plot(PCA_PVM_L, type='n', las=1, cex.lab=2, xlab="PC1(44.40%)",ylab="PC2(20.38%)")
points(PCA_PVM_L$x[,1], PCA_PVM_L$x[,2], pch = pch.gp_PVM_L, cex=3,lwd=3)
legend('bottomright',pt.cex=1.5, pt.lwd=3, cex=1.5, pch=c(1,2,4),legend = c('kalanoro','gregoric','bedjanic'),
       bty='n',text.font=4)
plot(0,type='n',axes=FALSE,ann=FALSE)
m_PVM_L = mshape(PVM_gpa_L$coords)
par(mar = c(0,0,0,0))
plotRefToTarget(m_PVM_L, PCA_PVM_L$shapes$shapes.comp1$min,mag=1,method = c("vector"),links = link_PVM)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PVM_L, PCA_PVM_L$shapes$shapes.comp1$max,mag=1,method = c("vector"),links = link_PVM)
plotRefToTarget(m_PVM_L, PCA_PVM_L$shapes$shapes.comp2$max,mag=1,method = c("vector"),links = link_PVM)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PVM_L, PCA_PVM_L$shapes$shapes.comp2$min,mag=1,method = c("vector"),links = link_PVM)

par(mar = c(4.5,4.5,1,1))
plot(PCA_PVM_S, type='n', las=1, cex.lab=2, xlab="PC1(36.39%)",ylab="PC2(22.09%)")
points(PCA_PVM_S$x[,1], PCA_PVM_S$x[,2], pch = pch.gp_PVM_S, cex=3,lwd=3)
legend('topright',pt.cex=1.5, pt.lwd=3, cex=1.5, pch=c(0,15),legend = c('hydatostella','rotundus'),
       bty='n',text.font=4)
plot(0,type='n',axes=FALSE,ann=FALSE)
m_PVM_S = mshape(PVM_gpa_S$coords)
par(mar = c(0,0,0,0))
plotRefToTarget(m_PVM_S, PCA_PVM_S$shapes$shapes.comp1$min,mag=1,method = c("vector"),links = link_PVM)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PVM_S, PCA_PVM_S$shapes$shapes.comp1$max,mag=1,method = c("vector"),links = link_PVM)
plotRefToTarget(m_PVM_S, PCA_PVM_S$shapes$shapes.comp2$max,mag=1,method = c("vector"),links = link_PVM)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PVM_S, PCA_PVM_S$shapes$shapes.comp2$min,mag=1,method = c("vector"),links = link_PVM)

#####Male palp RTA#####
MadaDolo_PRTA = read.csv("E:/study_PhD/Projects/Madagascar Dolomedes/landmark/Palp_Retrolateral_RTA.csv", header=T)
MadaDolo_PRTA_L = MadaDolo_PRTA[-c(127:198),]
MadaDolo_PRTA_S = MadaDolo_PRTA[-c(1:126),]
link_PRTA = matrix(data=c(1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9),nrow=8,ncol=2,byrow = TRUE)
Species_PRTA_L = as.factor(c(rep("kalanoro",length(MadaDolo_PRTA[MadaDolo_PRTA$Species=="kalanoro",]$Species)/9),
                             rep("kalanorosp2",length(MadaDolo_PRTA[MadaDolo_PRTA$Species=="kalanorosp2",]$Species)/9),
                             rep("sp2",length(MadaDolo_PRTA[MadaDolo_PRTA$Species=="sp2",]$Species)/9)))

Species_PRTA_S = as.factor(c(rep("sp3_Marojejy",length(MadaDolo_PRTA[MadaDolo_PRTA$Species=="sp3_Marojejy",]$Species)/9),
                             rep("sp3_Vakona",length(MadaDolo_PRTA[MadaDolo_PRTA$Species=="sp3_Vakona",]$Species)/9)))

PRTA_L = as.matrix(cbind(X=MadaDolo_PRTA_L[,5], Y=MadaDolo_PRTA_L[,6])) %>% arrayspecs(.,9,2)
PRTA_S = as.matrix(cbind(X=MadaDolo_PRTA_S[,5], Y=MadaDolo_PRTA_S[,6])) %>% arrayspecs(.,9,2)

names(pch_L) = levels(Species_PRTA_L)
names(pch_S) = levels(Species_PRTA_S)
pch.gp_PRTA_L = pch_L[match(Species_PRTA_L, names(pch_L))]
pch.gp_PRTA_S = pch_S[match(Species_PRTA_S, names(pch_S))]

PRTA_gpa_L = gpagen(PRTA_L) %>% rotate.coords(. ,type=c("flipY"))
#plot(PRTA_gpa_L,links=link_PRTA)
ref_PRTA_L = mshape(PRTA_gpa_L$coords)
PRTA_gpa_S = gpagen(PRTA_S) %>% rotate.coords(. ,type=c("flipY"))
#plot(PRTA_gpa_S,links=link_PRTA)
ref_PRTA_S = mshape(PRTA_gpa_S$coords)

PCA_PRTA_L = gm.prcomp(PRTA_gpa_L$coords)
summary(PCA_PRTA_L)
PCA_PRTA_S = gm.prcomp(PRTA_gpa_S$coords)
summary(PCA_PRTA_S)

layout(mat1, widths=c(2,2,1,2), heights=c(2,1,2,2))
par(mar = c(4.5,4.5,1,1))
plot(PCA_PRTA_L, type='n', las=1, cex.lab=2, xlab="PC1(39.49%)",ylab="PC2(30.53%)")
points(PCA_PRTA_L$x[,1], PCA_PRTA_L$x[,2], pch = pch.gp_PRTA_L, cex=3,lwd=3)
legend('bottomleft',pt.cex=1.5, pt.lwd=3, cex=1.5, pch=c(1,2,4),legend = c('kalanoro','gregoric','bedjanic'),
       bty='n',text.font=4)
plot(0,type='n',axes=FALSE,ann=FALSE)
m_PRTA_L = mshape(PRTA_gpa_L$coords)
par(mar = c(0,0,0,0))
plotRefToTarget(m_PRTA_L, PCA_PRTA_L$shapes$shapes.comp1$min,mag=1,method = c("vector"),links = link_PRTA)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PRTA_L, PCA_PRTA_L$shapes$shapes.comp1$max,mag=1,method = c("vector"),links = link_PRTA)
plotRefToTarget(m_PRTA_L, PCA_PRTA_L$shapes$shapes.comp2$max,mag=1,method = c("vector"),links = link_PRTA)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PRTA_L, PCA_PRTA_L$shapes$shapes.comp2$min,mag=1,method = c("vector"),links = link_PRTA)

par(mar = c(4.5,4.5,1,1))
plot(PCA_PRTA_S, type='n', las=1, cex.lab=2, xlab="PC1(55.74%)",ylab="PC2(17.43%)")
points(PCA_PRTA_S$x[,1], PCA_PRTA_S$x[,2], pch = pch.gp_PRTA_S, cex=3,lwd=3)
legend('bottomleft',pt.cex=1.5, pt.lwd=3, cex=1.5, pch=c(0,15),legend = c('hydatostella','rotundus'),
       bty='n',text.font=4)
plot(0,type='n',axes=FALSE,ann=FALSE)
m_PRTA_S = mshape(PRTA_gpa_S$coords)
par(mar = c(0,0,0,0))
plotRefToTarget(m_PRTA_S, PCA_PRTA_S$shapes$shapes.comp1$min,mag=1,method = c("vector"),links = link_PRTA)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PRTA_S, PCA_PRTA_S$shapes$shapes.comp1$max,mag=1,method = c("vector"),links = link_PRTA)
plotRefToTarget(m_PRTA_S, PCA_PRTA_S$shapes$shapes.comp2$max,mag=1,method = c("vector"),links = link_PRTA)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PRTA_S, PCA_PRTA_S$shapes$shapes.comp2$min,mag=1,method = c("vector"),links = link_PRTA)

#####Male palp embolus ventral view#####
MadaDolo_PVE = read.csv("E:/study_PhD/Projects/Madagascar Dolomedes/landmark/Palp_Ventral_E.csv", header=T)
MadaDolo_PVE_L = MadaDolo_PVE[-c(267:418),]
MadaDolo_PVE_S = MadaDolo_PVE[-c(1:266),]
link_PVE = matrix(data=c( 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9, 10, 10, 1,
                          1, 11, 11, 12, 12, 13, 13, 14, 14, 15, 15, 16, 16, 17, 17, 18, 18, 19, 19, 2),
                    nrow=19,ncol=2,byrow = TRUE)
Species_PVE_L = as.factor(c(rep("kalanoro",length(MadaDolo_PVE[MadaDolo_PVE$Species=="kalanoro",]$Species)/19),
                              rep("kalanorosp2",length(MadaDolo_PVE[MadaDolo_PVE$Species=="kalanorosp2",]$Species)/19),
                              rep("sp2",length(MadaDolo_PVE[MadaDolo_PVE$Species=="sp2",]$Species)/19)))

Species_PVE_S = as.factor(c(rep("sp3_Marojejy",length(MadaDolo_PVE[MadaDolo_PVE$Species=="sp3_Marojejy",]$Species)/19),
                              rep("sp3_Vakona",length(MadaDolo_PVE[MadaDolo_PVE$Species=="sp3_Vakona",]$Species)/19)))

PVE_L = as.matrix(cbind(X=MadaDolo_PVE_L[,5], Y=MadaDolo_PVE_L[,6])) %>% arrayspecs(.,19,2)
PVE_S = as.matrix(cbind(X=MadaDolo_PVE_S[,5], Y=MadaDolo_PVE_S[,6])) %>% arrayspecs(.,19,2)

names(pch_L) = levels(Species_PVE_L)
names(pch_S) = levels(Species_PVE_S)
pch.gp_PVE_L = pch_L[match(Species_PVE_L, names(pch_L))]
pch.gp_PVE_S = pch_S[match(Species_PVE_S, names(pch_S))]

PVE_gpa_L = gpagen(PVE_L) %>% rotate.coords(. ,type=c("flipY"))
#plot(PVE_gpa_L,links=link_PVE)
ref_PVE_L = mshape(PVE_gpa_L$coords)
PVE_gpa_S = gpagen(PVE_S) %>% rotate.coords(. ,type=c("flipY"))
#plot(PVE_gpa_S,links=link_PVE)
ref_PVE_S = mshape(PVE_gpa_S$coords)

PCA_PVE_L = gm.prcomp(PVE_gpa_L$coords)
summary(PCA_PVE_L)
PCA_PVE_S = gm.prcomp(PVE_gpa_S$coords)
summary(PCA_PVE_S)

layout(mat1, widths=c(2,2,1,2), heights=c(2,1,2,2))
par(mar = c(4.5,4.5,1,1))
plot(PCA_PVE_L, type='n', las=1, cex.lab=2, xlab="PC1(59.32%)",ylab="PC2(20.75%)")
points(PCA_PVE_L$x[,1], PCA_PVE_L$x[,2], pch = pch.gp_PVE_L, cex=3,lwd=3)
legend('topright',pt.cex=1.5, pt.lwd=3, cex=1.5, pch=c(1,2,4),legend = c('kalanoro','gregoric','bedjanic'),
       bty='n',text.font=4)
plot(0,type='n',axes=FALSE,ann=FALSE)
m_PVE_L = mshape(PVE_gpa_L$coords)
par(mar = c(0,0,0,0))
plotRefToTarget(m_PVE_L, PCA_PVE_L$shapes$shapes.comp1$min,mag=1,method = c("vector"),links = link_PVE)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PVE_L, PCA_PVE_L$shapes$shapes.comp1$max,mag=1,method = c("vector"),links = link_PVE)
plotRefToTarget(m_PVE_L, PCA_PVE_L$shapes$shapes.comp2$max,mag=1,method = c("vector"),links = link_PVE)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PVE_L, PCA_PVE_L$shapes$shapes.comp2$min,mag=1,method = c("vector"),links = link_PVE)

par(mar = c(4.5,4.5,1,1))
plot(PCA_PVE_S, type='n', las=1, cex.lab=2, xlab="PC1(62.50%)",ylab="PC2(13.29%)")
points(PCA_PVE_S$x[,1], PCA_PVE_S$x[,2], pch = pch.gp_PVE_S, cex=3,lwd=3)
legend('bottomleft',pt.cex=1.5, pt.lwd=3, cex=1.5, pch=c(0,15),legend = c('hydatostella','rotundus'),
       bty='n',text.font=4)
plot(0,type='n',axes=FALSE,ann=FALSE)
m_PVE_S = mshape(PVE_gpa_S$coords)
par(mar = c(0,0,0,0))
plotRefToTarget(m_PVE_S, PCA_PVE_S$shapes$shapes.comp1$min,mag=1,method = c("vector"),links = link_PVE)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PVE_S, PCA_PVE_S$shapes$shapes.comp1$max,mag=1,method = c("vector"),links = link_PVE)
plotRefToTarget(m_PVE_S, PCA_PVE_S$shapes$shapes.comp2$max,mag=1,method = c("vector"),links = link_PVE)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PVE_S, PCA_PVE_S$shapes$shapes.comp2$min,mag=1,method = c("vector"),links = link_PVE)

#####Male palp fulcrum ventral view#####
MadaDolo_PVF = read.csv("E:/study_PhD/Projects/Madagascar Dolomedes/landmark/Palp_Ventral_F.csv", header=T)
MadaDolo_PVF_L = MadaDolo_PVF[-c(197:308),]
MadaDolo_PVF_S = MadaDolo_PVF[-c(1:196),]
link_PVF = matrix(data=c(14,13,13,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,7,9,11,11,12),
                  nrow=14,ncol=2,byrow = TRUE)
Species_PVF_L = as.factor(c(rep("kalanoro",length(MadaDolo_PVF[MadaDolo_PVF$Species=="kalanoro",]$Species)/14),
                            rep("kalanorosp2",length(MadaDolo_PVF[MadaDolo_PVF$Species=="kalanorosp2",]$Species)/14),
                            rep("sp2",length(MadaDolo_PVF[MadaDolo_PVF$Species=="sp2",]$Species)/14)))

Species_PVF_S = as.factor(c(rep("sp3_Marojejy",length(MadaDolo_PVF[MadaDolo_PVF$Species=="sp3_Marojejy",]$Species)/14),
                            rep("sp3_Vakona",length(MadaDolo_PVF[MadaDolo_PVF$Species=="sp3_Vakona",]$Species)/14)))

PVF_L = as.matrix(cbind(X=MadaDolo_PVF_L[,5], Y=MadaDolo_PVF_L[,6])) %>% arrayspecs(.,14,2)
PVF_S = as.matrix(cbind(X=MadaDolo_PVF_S[,5], Y=MadaDolo_PVF_S[,6])) %>% arrayspecs(.,14,2)

names(pch_L) = levels(Species_PVF_L)
names(pch_S) = levels(Species_PVF_S)
pch.gp_PVF_L = pch_L[match(Species_PVF_L, names(pch_L))]
pch.gp_PVF_S = pch_S[match(Species_PVF_S, names(pch_S))]

PVF_gpa_L = gpagen(PVF_L) %>% rotate.coords(. ,type=c("flipY"))
#plot(PVF_gpa_L,links=link_PVF)
ref_PVF_L = mshape(PVF_gpa_L$coords)
PVF_gpa_S = gpagen(PVF_S) %>% rotate.coords(. ,type=c("flipY"))
#plot(PVF_gpa_S,links=link_PVF)
ref_PVF_S = mshape(PVF_gpa_S$coords)

PCA_PVF_L = gm.prcomp(PVF_gpa_L$coords)
summary(PCA_PVF_L)
PCA_PVF_S = gm.prcomp(PVF_gpa_S$coords)
summary(PCA_PVF_S)

layout(mat1, widths=c(2,2,1,2), heights=c(2,1,2,2))
par(mar = c(4.5,4.5,1,1))
plot(PCA_PVF_L, type='n', las=1, cex.lab=2, xlab="PC1(52.60%)",ylab="PC2(17.08%)")
points(PCA_PVF_L$x[,1], PCA_PVF_L$x[,2], pch = pch.gp_PVF_L, cex=3,lwd=3)
legend('bottomleft',pt.cex=1.5, pt.lwd=3, cex=1.5, pch=c(1,2,4),legend = c('kalanoro','gregoric','bedjanic'),
       bty='n',text.font=4)
plot(0,type='n',axes=FALSE,ann=FALSE)
m_PVF_L = mshape(PVF_gpa_L$coords)
par(mar = c(0,0,0,0))
plotRefToTarget(m_PVF_L, PCA_PVF_L$shapes$shapes.comp1$min,mag=1,method = c("vector"),links = link_PVF)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PVF_L, PCA_PVF_L$shapes$shapes.comp1$max,mag=1,method = c("vector"),links = link_PVF)
plotRefToTarget(m_PVF_L, PCA_PVF_L$shapes$shapes.comp2$max,mag=1,method = c("vector"),links = link_PVF)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PVF_L, PCA_PVF_L$shapes$shapes.comp2$min,mag=1,method = c("vector"),links = link_PVF)

par(mar = c(4.5,4.5,1,1))
plot(PCA_PVF_S, type='n', las=1, cex.lab=2, xlab="PC1(45.84%)",ylab="PC2(23.15%)")
points(PCA_PVF_S$x[,1], PCA_PVF_S$x[,2], pch = pch.gp_PVF_S, cex=3,lwd=3)
legend('topright',pt.cex=1.5, pt.lwd=3, cex=1.5, pch=c(0,15),legend = c('hydatostella','rotundus'),
       bty='n',text.font=4)
plot(0,type='n',axes=FALSE,ann=FALSE)
m_PVF_S = mshape(PVF_gpa_S$coords)
par(mar = c(0,0,0,0))
plotRefToTarget(m_PVF_S, PCA_PVF_S$shapes$shapes.comp1$min,mag=1,method = c("vector"),links = link_PVF)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PVF_S, PCA_PVF_S$shapes$shapes.comp1$max,mag=1,method = c("vector"),links = link_PVF)
plotRefToTarget(m_PVF_S, PCA_PVF_S$shapes$shapes.comp2$max,mag=1,method = c("vector"),links = link_PVF)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PVF_S, PCA_PVF_S$shapes$shapes.comp2$min,mag=1,method = c("vector"),links = link_PVF)

#####Male palp embolus#####
MadaDolo_PE = read.csv("E:/study_PhD/Projects/Madagascar Dolomedes/landmark/Palp_E.csv", header=T)
MadaDolo_PE_L = MadaDolo_PE[-c(239:374),]
MadaDolo_PE_S = MadaDolo_PE[-c(1:238),]
link_PE = matrix(data=c( 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9, 10, 
                         10, 11, 11, 12, 12, 13, 13, 14, 14, 15, 15, 16, 16, 17), nrow=16,ncol=2,byrow = TRUE)
Species_PE_L = as.factor(c(rep("kalanoro",length(MadaDolo_PE[MadaDolo_PE$Species=="kalanoro",]$Species)/17),
                           rep("kalanorosp2",length(MadaDolo_PE[MadaDolo_PE$Species=="kalanorosp2",]$Species)/17),
                           rep("sp2",length(MadaDolo_PE[MadaDolo_PE$Species=="sp2",]$Species)/17)))

Species_PE_S = as.factor(c(rep("sp3_Marojejy",length(MadaDolo_PE[MadaDolo_PE$Species=="sp3_Marojejy",]$Species)/17),
                           rep("sp3_Vakona",length(MadaDolo_PE[MadaDolo_PE$Species=="sp3_Vakona",]$Species)/17)))

PE_L = as.matrix(cbind(X=MadaDolo_PE_L[,5], Y=MadaDolo_PE_L[,6])) %>% arrayspecs(.,17,2)
PE_S = as.matrix(cbind(X=MadaDolo_PE_S[,5], Y=MadaDolo_PE_S[,6])) %>% arrayspecs(.,17,2)

names(pch_L) = levels(Species_PE_L)
names(pch_S) = levels(Species_PE_S)
pch.gp_PE_L = pch_L[match(Species_PE_L, names(pch_L))]
pch.gp_PE_S = pch_S[match(Species_PE_S, names(pch_S))]

PE_gpa_L = gpagen(PE_L) %>% rotate.coords(. ,type=c("flipY"))
#plot(PE_gpa_L,links=link_PE)
ref_PE_L = mshape(PE_gpa_L$coords)
PE_gpa_S = gpagen(PE_S) %>% rotate.coords(. ,type=c("flipY"))
#plot(PE_gpa_S,links=link_PE)
ref_PE_S = mshape(PE_gpa_S$coords)

PCA_PE_L = gm.prcomp(PE_gpa_L$coords)
summary(PCA_PE_L)
PCA_PE_S = gm.prcomp(PE_gpa_S$coords)
summary(PCA_PE_S)

layout(mat1, widths=c(2,2,1,2), heights=c(2,1,2,2))
par(mar = c(4.5,4.5,1,1))
plot(PCA_PE_L, type='n', las=1, cex.lab=2, xlab="PC1(84.00%)",ylab="PC2(9.56%)")
points(PCA_PE_L$x[,1], PCA_PE_L$x[,2], pch = pch.gp_PE_L, cex=3,lwd=3)
legend('bottomright',pt.cex=1.5, pt.lwd=3, cex=1.5, pch=c(1,2,4),legend = c('kalanoro','gregoric','bedjanic'),
       bty='n',text.font=4)
plot(0,type='n',axes=FALSE,ann=FALSE)
m_PE_L = mshape(PE_gpa_L$coords)
par(mar = c(0,0,0,0))
plotRefToTarget(m_PE_L, PCA_PE_L$shapes$shapes.comp1$min,mag=1,method = c("vector"),links = link_PE)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PE_L, PCA_PE_L$shapes$shapes.comp1$max,mag=1,method = c("vector"),links = link_PE)
plotRefToTarget(m_PE_L, PCA_PE_L$shapes$shapes.comp2$max,mag=1,method = c("vector"),links = link_PE)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PE_L, PCA_PE_L$shapes$shapes.comp2$min,mag=1,method = c("vector"),links = link_PE)

par(mar = c(4.5,4.5,1,1))
plot(PCA_PE_S, type='n', las=1, cex.lab=2, xlab="PC1(65.39%)",ylab="PC2(15.85%)")
points(PCA_PE_S$x[,1], PCA_PE_S$x[,2], pch = pch.gp_PE_S, cex=3,lwd=3)
legend('bottomright',pt.cex=1.5, pt.lwd=3, cex=1.5, pch=c(0,15),legend = c('hydatostella','rotundus'),
       bty='n',text.font=4)
plot(0,type='n',axes=FALSE,ann=FALSE)
m_PE_S = mshape(PE_gpa_S$coords)
par(mar = c(0,0,0,0))
plotRefToTarget(m_PE_S, PCA_PE_S$shapes$shapes.comp1$min,mag=1,method = c("vector"),links = link_PE)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PE_S, PCA_PE_S$shapes$shapes.comp1$max,mag=1,method = c("vector"),links = link_PE)
plotRefToTarget(m_PE_S, PCA_PE_S$shapes$shapes.comp2$max,mag=1,method = c("vector"),links = link_PE)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PE_S, PCA_PE_S$shapes$shapes.comp2$min,mag=1,method = c("vector"),links = link_PE)

#####Male palp lateral subtermial apophysis#####
MadaDolo_PLA = read.csv("E:/study_PhD/Projects/Madagascar Dolomedes/landmark/Palp_LA.csv", header=T)
MadaDolo_PLA_L = MadaDolo_PLA[-c(155:242),]
MadaDolo_PLA_S = MadaDolo_PLA[-c(1:154),]
link_PLA = matrix(data=c( 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9, 10, 10, 11),
                  nrow=10,ncol=2,byrow = TRUE)
Species_PLA_L = as.factor(c(rep("kalanoro",length(MadaDolo_PLA[MadaDolo_PLA$Species=="kalanoro",]$Species)/11),
                            rep("kalanorosp2",length(MadaDolo_PLA[MadaDolo_PLA$Species=="kalanorosp2",]$Species)/11),
                            rep("sp2",length(MadaDolo_PLA[MadaDolo_PLA$Species=="sp2",]$Species)/11)))

Species_PLA_S = as.factor(c(rep("sp3_Marojejy",length(MadaDolo_PLA[MadaDolo_PLA$Species=="sp3_Marojejy",]$Species)/11),
                            rep("sp3_Vakona",length(MadaDolo_PLA[MadaDolo_PLA$Species=="sp3_Vakona",]$Species)/11)))

PLA_L = as.matrix(cbind(X=MadaDolo_PLA_L[,5], Y=MadaDolo_PLA_L[,6])) %>% arrayspecs(.,11,2)
PLA_S = as.matrix(cbind(X=MadaDolo_PLA_S[,5], Y=MadaDolo_PLA_S[,6])) %>% arrayspecs(.,11,2)

names(pch_L) = levels(Species_PLA_L)
names(pch_S) = levels(Species_PLA_S)
pch.gp_PLA_L = pch_L[match(Species_PLA_L, names(pch_L))]
pch.gp_PLA_S = pch_S[match(Species_PLA_S, names(pch_S))]

PLA_gpa_L = gpagen(PLA_L) %>% rotate.coords(. ,type=c("flipY"))
#plot(PLA_gpa_L,links=link_PLA)
ref_PLA_L = mshape(PLA_gpa_L$coords)
PLA_gpa_S = gpagen(PLA_S) %>% rotate.coords(. ,type=c("flipY"))
#plot(PLA_gpa_S,links=link_PLA)
ref_PLA_S = mshape(PLA_gpa_S$coords)

PCA_PLA_L = gm.prcomp(PLA_gpa_L$coords)
summary(PCA_PLA_L)
PCA_PLA_S = gm.prcomp(PLA_gpa_S$coords)
summary(PCA_PLA_S)

layout(mat1, widths=c(2,2,1,2), heights=c(2,1,2,2))
par(mar = c(4.5,4.5,1,1))
plot(PCA_PLA_L, type='n', las=1, cex.lab=2, xlab="PC1(36.59%)",ylab="PC2(22.35%)")
points(PCA_PLA_L$x[,1], PCA_PLA_L$x[,2], pch = pch.gp_PLA_L, cex=3,lwd=3)
legend('bottomleft',pt.cex=1.5, pt.lwd=3, cex=1.5, pch=c(1,2,4),legend = c('kalanoro','gregoric','bedjanic'),
       bty='n',text.font=4)
plot(0,type='n',axes=FALSE,ann=FALSE)
m_PLA_L = mshape(PLA_gpa_L$coords)
par(mar = c(0,0,0,0))
plotRefToTarget(m_PLA_L, PCA_PLA_L$shapes$shapes.comp1$min,mag=1,method = c("vector"),links = link_PLA)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PLA_L, PCA_PLA_L$shapes$shapes.comp1$max,mag=1,method = c("vector"),links = link_PLA)
plotRefToTarget(m_PLA_L, PCA_PLA_L$shapes$shapes.comp2$max,mag=1,method = c("vector"),links = link_PLA)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PLA_L, PCA_PLA_L$shapes$shapes.comp2$min,mag=1,method = c("vector"),links = link_PLA)

par(mar = c(4.5,4.5,1,1))
plot(PCA_PLA_S, type='n', las=1, cex.lab=2, xlab="PC1(41.47%)",ylab="PC2(24.44%)")
points(PCA_PLA_S$x[,1], PCA_PLA_S$x[,2], pch = pch.gp_PLA_S, cex=3,lwd=3)
legend('topleft',pt.cex=1.5, pt.lwd=3, cex=1.5, pch=c(0,15),legend = c('hydatostella','rotundus'),
       bty='n',text.font=4)
plot(0,type='n',axes=FALSE,ann=FALSE)
m_PLA_S = mshape(PLA_gpa_S$coords)
par(mar = c(0,0,0,0))
plotRefToTarget(m_PLA_S, PCA_PLA_S$shapes$shapes.comp1$min,mag=1,method = c("vector"),links = link_PLA)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PLA_S, PCA_PLA_S$shapes$shapes.comp1$max,mag=1,method = c("vector"),links = link_PLA)
plotRefToTarget(m_PLA_S, PCA_PLA_S$shapes$shapes.comp2$max,mag=1,method = c("vector"),links = link_PLA)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PLA_S, PCA_PLA_S$shapes$shapes.comp2$min,mag=1,method = c("vector"),links = link_PLA)

#####Male palp fulcrum#####
MadaDolo_PF = read.csv("E:/study_PhD/Projects/Madagascar Dolomedes/landmark/Palp_F.csv", header=T)
MadaDolo_PF_L = MadaDolo_PF[-c(239:374),]
MadaDolo_PF_S = MadaDolo_PF[-c(1:238),]
link_PF = matrix(data=c( 17, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 
                         8, 9, 9, 10, 10, 11, 11, 12, 12, 13, 13, 14, 14, 15, 15, 16),
                 nrow=16,ncol=2,byrow = TRUE)
Species_PF_L = as.factor(c(rep("kalanoro",length(MadaDolo_PF[MadaDolo_PF$Species=="kalanoro",]$Species)/17),
                           rep("kalanorosp2",length(MadaDolo_PF[MadaDolo_PF$Species=="kalanorosp2",]$Species)/17),
                           rep("sp2",length(MadaDolo_PF[MadaDolo_PF$Species=="sp2",]$Species)/17)))

Species_PF_S = as.factor(c(rep("sp3_Marojejy",length(MadaDolo_PF[MadaDolo_PF$Species=="sp3_Marojejy",]$Species)/17),
                           rep("sp3_Vakona",length(MadaDolo_PF[MadaDolo_PF$Species=="sp3_Vakona",]$Species)/17)))

PF_L = as.matrix(cbind(X=MadaDolo_PF_L[,5], Y=MadaDolo_PF_L[,6])) %>% arrayspecs(.,17,2)
PF_S = as.matrix(cbind(X=MadaDolo_PF_S[,5], Y=MadaDolo_PF_S[,6])) %>% arrayspecs(.,17,2)

names(pch_L) = levels(Species_PF_L)
names(pch_S) = levels(Species_PF_S)
pch.gp_PF_L = pch_L[match(Species_PF_L, names(pch_L))]
pch.gp_PF_S = pch_S[match(Species_PF_S, names(pch_S))]

PF_gpa_L = gpagen(PF_L) %>% rotate.coords(. ,type=c("flipX")) %>% rotate.coords(. ,type=c("rotateC"))
#plot(PF_gpa_L,links=link_PF)
ref_PF_L = mshape(PF_gpa_L$coords)
PF_gpa_S = gpagen(PF_S) %>% rotate.coords(. ,type=c("flipX")) %>% rotate.coords(. ,type=c("rotateC"))
#plot(PF_gpa_S,links=link_PF)
ref_PF_S = mshape(PF_gpa_S$coords)

PCA_PF_L = gm.prcomp(PF_gpa_L$coords)
summary(PCA_PF_L)
PCA_PF_S = gm.prcomp(PF_gpa_S$coords)
summary(PCA_PF_S)

layout(mat1, widths=c(2,2,1,2), heights=c(2,1,2,2))
par(mar = c(4.5,4.5,1,1))
plot(PCA_PF_L, type='n', las=1, cex.lab=2, xlab="PC1(30.81%)",ylab="PC2(21.05%)")
points(PCA_PF_L$x[,1], PCA_PF_L$x[,2], pch = pch.gp_PF_L, cex=3,lwd=3)
legend('bottomleft',pt.cex=1.5, pt.lwd=3, cex=1.5, pch=c(1,2,4),legend = c('kalanoro','gregoric','bedjanic'),
       bty='n',text.font=4)
plot(0,type='n',axes=FALSE,ann=FALSE)
m_PF_L = mshape(PF_gpa_L$coords)
par(mar = c(0,0,0,0))
plotRefToTarget(m_PF_L, PCA_PF_L$shapes$shapes.comp1$min,mag=1,method = c("vector"),links = link_PF)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PF_L, PCA_PF_L$shapes$shapes.comp1$max,mag=1,method = c("vector"),links = link_PF)
plotRefToTarget(m_PF_L, PCA_PF_L$shapes$shapes.comp2$max,mag=1,method = c("vector"),links = link_PF)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PF_L, PCA_PF_L$shapes$shapes.comp2$min,mag=1,method = c("vector"),links = link_PF)

par(mar = c(4.5,4.5,1,1))
plot(PCA_PF_S, type='n', las=1, cex.lab=2, xlab="PC1(39.21%)",ylab="PC2(23.17%)")
points(PCA_PF_S$x[,1], PCA_PF_S$x[,2], pch = pch.gp_PF_S, cex=3,lwd=3)
legend('topright',pt.cex=1.5, pt.lwd=3, cex=1.5, pch=c(0,15),legend = c('hydatostella','rotundus'),
       bty='n',text.font=4)
plot(0,type='n',axes=FALSE,ann=FALSE)
m_PF_S = mshape(PF_gpa_S$coords)
par(mar = c(0,0,0,0))
plotRefToTarget(m_PF_S, PCA_PF_S$shapes$shapes.comp1$min,mag=1,method = c("vector"),links = link_PF)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PF_S, PCA_PF_S$shapes$shapes.comp1$max,mag=1,method = c("vector"),links = link_PF)
plotRefToTarget(m_PF_S, PCA_PF_S$shapes$shapes.comp2$max,mag=1,method = c("vector"),links = link_PF)
plot(0,type='n',axes=FALSE,ann=FALSE)
plotRefToTarget(m_PF_S, PCA_PF_S$shapes$shapes.comp2$min,mag=1,method = c("vector"),links = link_PF)

#####Shape consensus of each group#####
mat2 = matrix(c( 1,  2,  3,  4,  5,  6,  7,
                 8,  9, 10, 11,  5, 12, 13,
                14, 15, 16, 17,  5, 18, 19,
                20, 21, 22, 23,  5, 24, 25 ), nrow=4,ncol=7,byrow = TRUE)
mat3 = matrix(c( 1,  2,  3,  4,  5,  6,  7,
                 8,  9, 10, 11,  5, 12, 13,
                14, 15, 16, 17,  5, 18, 19,
                20, 21, 22, 23,  5, 24, 25,
                26, 27, 28, 29,  5, 30, 31 ), nrow=5,ncol=7,byrow = TRUE)
#Female 
layout(mat2, widths=c(1,3,3,3,1,3,3), heights=c(1,3,3,3))
par(mar = c(0,0,0,0))
plot(0,ylim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('kalanoro'),font=4,cex=1.5)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('gregoric'),font=4,cex=1.5)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('bedjanic'),font=4,cex=1.5)
plot(0,ylim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
points (c(1,1), c(-0.45,0.45), type='l', lwd=3)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('hydatostella'),font=4,cex=1.5)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('rotundus'),font=4,cex=1.5)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('Epigynal\nmargin'),font=2,srt=90,cex=1.5)
gdf_EpVO_L = geomorph.data.frame(EpVO_gpa_L, species=Species_EpVO_L)
fit.shape_EpVO_L = procD.lm(coords ~ species, iter=999, turbo=TRUE, data=gdf_EpVO_L, print.progress=FALSE)
plotRefToTarget(fit.shape_EpVO_L$GM$fitted[,,1], fit.shape_EpVO_L$GM$fitted[,,1], method = c("points"), links = link_EpVO)
plotRefToTarget(fit.shape_EpVO_L$GM$fitted[,,6], fit.shape_EpVO_L$GM$fitted[,,6], method = c("points"), links = link_EpVO)
plotRefToTarget(fit.shape_EpVO_L$GM$fitted[,,8], fit.shape_EpVO_L$GM$fitted[,,8], method = c("points"), links = link_EpVO)
gdf_EpVO_S = geomorph.data.frame(EpVO_gpa_S, species=Species_EpVO_S)
fit.shape_EpVO_S = procD.lm(coords ~ species, iter=999, turbo=TRUE, data=gdf_EpVO_S, print.progress=FALSE)
plotRefToTarget(fit.shape_EpVO_S$GM$fitted[,,1], fit.shape_EpVO_S$GM$fitted[,,1], method = c("points"), links = link_EpVO)
plotRefToTarget(fit.shape_EpVO_S$GM$fitted[,,6], fit.shape_EpVO_S$GM$fitted[,,6], method = c("points"), links = link_EpVO)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('Epigynal\nmiddle field'),font=2,srt=90,cex=1.5)
gdf_EpVM_L = geomorph.data.frame(EpVM_gpa_L, species=Species_EpVM_L)
fit.shape_EpVM_L = procD.lm(coords ~ species, iter=999, turbo=TRUE, data=gdf_EpVM_L, print.progress=FALSE)
plotRefToTarget(fit.shape_EpVM_L$GM$fitted[,,1], fit.shape_EpVM_L$GM$fitted[,,1], method = c("points"), links = link_EpVM)
plotRefToTarget(fit.shape_EpVM_L$GM$fitted[,,6], fit.shape_EpVM_L$GM$fitted[,,6], method = c("points"), links = link_EpVM)
plotRefToTarget(fit.shape_EpVM_L$GM$fitted[,,8], fit.shape_EpVM_L$GM$fitted[,,8], method = c("points"), links = link_EpVM)
gdf_EpVM_S = geomorph.data.frame(EpVM_gpa_S, species=Species_EpVM_S)
fit.shape_EpVM_S = procD.lm(coords ~ species, iter=999, turbo=TRUE, data=gdf_EpVM_S, print.progress=FALSE)
plotRefToTarget(fit.shape_EpVM_S$GM$fitted[,,1], fit.shape_EpVM_S$GM$fitted[,,1], method = c("points"), links = link_EpVM)
plotRefToTarget(fit.shape_EpVM_S$GM$fitted[,,6], fit.shape_EpVM_S$GM$fitted[,,6], method = c("points"), links = link_EpVM)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('Vulva'),font=2,srt=90,cex=1.5)
gdf_EpD_L = geomorph.data.frame(EpD_gpa_L, species=Species_EpD_L)
fit.shape_EpD_L = procD.lm(coords ~ species, iter=999, turbo=TRUE, data=gdf_EpD_L, print.progress=FALSE)
plotRefToTarget(fit.shape_EpD_L$GM$fitted[,,1], fit.shape_EpD_L$GM$fitted[,,1], method = c("points"), links = link_EpD)
plotRefToTarget(fit.shape_EpD_L$GM$fitted[,,6], fit.shape_EpD_L$GM$fitted[,,6], method = c("points"), links = link_EpD)
plotRefToTarget(fit.shape_EpD_L$GM$fitted[,,8], fit.shape_EpD_L$GM$fitted[,,8], method = c("points"), links = link_EpD)
gdf_EpD_S = geomorph.data.frame(EpD_gpa_S, species=Species_EpD_S)
fit.shape_EpD_S = procD.lm(coords ~ species, iter=999, turbo=TRUE, data=gdf_EpD_S, print.progress=FALSE)
plotRefToTarget(fit.shape_EpD_S$GM$fitted[,,1], fit.shape_EpD_S$GM$fitted[,,1], method = c("points"), links = link_EpD)
plotRefToTarget(fit.shape_EpD_S$GM$fitted[,,6], fit.shape_EpD_S$GM$fitted[,,6], method = c("points"), links = link_EpD)

#Male palp
layout(mat3, widths=c(1,3,3,3,1,3,3), heights=c(1,4,3,3,3))
par(mar = c(0,0,0,0))
plot(0,ylim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('kalanoro'),font=4,cex=1.5)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('gregoric'),font=4,cex=1.5)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('bedjanic'),font=4,cex=1.5)
plot(0,ylim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
points (c(1,1), c(-0.45,0.45), type='l', lwd=3)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('hydatostella'),font=4,cex=1.5)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('rotundus'),font=4,cex=1.5)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('Median apophysis'),font=2,srt=90,cex=1.5)
gdf_PVM_L = geomorph.data.frame(PVM_gpa_L, species=Species_PVM_L)
fit.shape_PVM_L = procD.lm(coords ~ species, iter=999, turbo=TRUE, data=gdf_PVM_L, print.progress=FALSE)
plotRefToTarget(fit.shape_PVM_L$GM$fitted[,,1], fit.shape_PVM_L$GM$fitted[,,1], method = c("points"), links = link_PVM)
plotRefToTarget(fit.shape_PVM_L$GM$fitted[,,6], fit.shape_PVM_L$GM$fitted[,,6], method = c("points"), links = link_PVM)
plotRefToTarget(fit.shape_PVM_L$GM$fitted[,,8], fit.shape_PVM_L$GM$fitted[,,8], method = c("points"), links = link_PVM)
gdf_PVM_S = geomorph.data.frame(PVM_gpa_S, species=Species_PVM_S)
fit.shape_PVM_S = procD.lm(coords ~ species, iter=999, turbo=TRUE, data=gdf_PVM_S, print.progress=FALSE)
plotRefToTarget(fit.shape_PVM_S$GM$fitted[,,1], fit.shape_PVM_S$GM$fitted[,,1], method = c("points"), links = link_PVM)
plotRefToTarget(fit.shape_PVM_S$GM$fitted[,,3], fit.shape_PVM_S$GM$fitted[,,3], method = c("points"), links = link_PVM)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('Embolus\nventral view'),font=2,srt=90,cex=1.5)
gdf_PVE_L = geomorph.data.frame(PVE_gpa_L, species=Species_PVE_L)
fit.shape_PVE_L = procD.lm(coords ~ species, iter=999, turbo=TRUE, data=gdf_PVE_L, print.progress=FALSE)
plotRefToTarget(fit.shape_PVE_L$GM$fitted[,,1], fit.shape_PVE_L$GM$fitted[,,1], method = c("points"), links = link_PVE)
plotRefToTarget(fit.shape_PVE_L$GM$fitted[,,6], fit.shape_PVE_L$GM$fitted[,,6], method = c("points"), links = link_PVE)
plotRefToTarget(fit.shape_PVE_L$GM$fitted[,,8], fit.shape_PVE_L$GM$fitted[,,8], method = c("points"), links = link_PVE)
gdf_PVE_S = geomorph.data.frame(PVE_gpa_S, species=Species_PVE_S)
fit.shape_PVE_S = procD.lm(coords ~ species, iter=999, turbo=TRUE, data=gdf_PVE_S, print.progress=FALSE)
plotRefToTarget(fit.shape_PVE_S$GM$fitted[,,1], fit.shape_PVE_S$GM$fitted[,,1], method = c("points"), links = link_PVE)
plotRefToTarget(fit.shape_PVE_S$GM$fitted[,,3], fit.shape_PVE_S$GM$fitted[,,3], method = c("points"), links = link_PVE)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('Fulcrum\nventral view'),font=2,srt=90,cex=1.5)
gdf_PVF_L = geomorph.data.frame(PVF_gpa_L, species=Species_PVF_L)
fit.shape_PVF_L = procD.lm(coords ~ species, iter=999, turbo=TRUE, data=gdf_PVF_L, print.progress=FALSE)
plotRefToTarget(fit.shape_PVF_L$GM$fitted[,,1], fit.shape_PVF_L$GM$fitted[,,1], method = c("points"), links = link_PVF)
plotRefToTarget(fit.shape_PVF_L$GM$fitted[,,6], fit.shape_PVF_L$GM$fitted[,,6], method = c("points"), links = link_PVF)
plotRefToTarget(fit.shape_PVF_L$GM$fitted[,,8], fit.shape_PVF_L$GM$fitted[,,8], method = c("points"), links = link_PVF)
gdf_PVF_S = geomorph.data.frame(PVF_gpa_S, species=Species_PVF_S)
fit.shape_PVF_S = procD.lm(coords ~ species, iter=999, turbo=TRUE, data=gdf_PVF_S, print.progress=FALSE)
plotRefToTarget(fit.shape_PVF_S$GM$fitted[,,1], fit.shape_PVF_S$GM$fitted[,,1], method = c("points"), links = link_PVF)
plotRefToTarget(fit.shape_PVF_S$GM$fitted[,,3], fit.shape_PVF_S$GM$fitted[,,3], method = c("points"), links = link_PVF)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('RTA'),font=2,srt=90,cex=1.5)
gdf_PRTA_L = geomorph.data.frame(PRTA_gpa_L, species=Species_PRTA_L)
fit.shape_PRTA_L = procD.lm(coords ~ species, iter=999, turbo=TRUE, data=gdf_PRTA_L, print.progress=FALSE)
plotRefToTarget(fit.shape_PRTA_L$GM$fitted[,,1], fit.shape_PRTA_L$GM$fitted[,,1], method = c("points"), links = link_PRTA)
plotRefToTarget(fit.shape_PRTA_L$GM$fitted[,,6], fit.shape_PRTA_L$GM$fitted[,,6], method = c("points"), links = link_PRTA)
plotRefToTarget(fit.shape_PRTA_L$GM$fitted[,,8], fit.shape_PRTA_L$GM$fitted[,,8], method = c("points"), links = link_PRTA)
gdf_PRTA_S = geomorph.data.frame(PRTA_gpa_S, species=Species_PRTA_S)
fit.shape_PRTA_S = procD.lm(coords ~ species, iter=999, turbo=TRUE, data=gdf_PRTA_S, print.progress=FALSE)
plotRefToTarget(fit.shape_PRTA_S$GM$fitted[,,1], fit.shape_PRTA_S$GM$fitted[,,1], method = c("points"), links = link_PRTA)
plotRefToTarget(fit.shape_PRTA_S$GM$fitted[,,3], fit.shape_PRTA_S$GM$fitted[,,3], method = c("points"), links = link_PRTA)

#Male DST
layout(mat2, widths=c(1,3,3,3,1,3,3), heights=c(1,3,3,3))
par(mar = c(0,0,0,0))
plot(0,ylim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('kalanoro'),font=4,cex=1.5)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('gregoric'),font=4,cex=1.5)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('bedjanic'),font=4,cex=1.5)
plot(0,ylim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
points (c(1,1), c(-0.45,0.45), type='l', lwd=3)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('hydatostella'),font=4,cex=1.5)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('rotundus'),font=4,cex=1.5)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('Embolus'),font=2,srt=90,cex=1.5)
gdf_PE_L = geomorph.data.frame(PE_gpa_L, species=Species_PE_L)
fit.shape_PE_L = procD.lm(coords ~ species, iter=999, turbo=TRUE, data=gdf_PE_L, print.progress=FALSE)
plotRefToTarget(fit.shape_PE_L$GM$fitted[,,1], fit.shape_PE_L$GM$fitted[,,1], method = c("points"), links = link_PE)
plotRefToTarget(fit.shape_PE_L$GM$fitted[,,6], fit.shape_PE_L$GM$fitted[,,6], method = c("points"), links = link_PE)
plotRefToTarget(fit.shape_PE_L$GM$fitted[,,8], fit.shape_PE_L$GM$fitted[,,8], method = c("points"), links = link_PE)
gdf_PE_S = geomorph.data.frame(PE_gpa_S, species=Species_PE_S)
fit.shape_PE_S = procD.lm(coords ~ species, iter=999, turbo=TRUE, data=gdf_PE_S, print.progress=FALSE)
plotRefToTarget(fit.shape_PE_S$GM$fitted[,,1], fit.shape_PE_S$GM$fitted[,,1], method = c("points"), links = link_PE)
plotRefToTarget(fit.shape_PE_S$GM$fitted[,,3], fit.shape_PE_S$GM$fitted[,,3], method = c("points"), links = link_PE)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('Fulcrum'),font=2,srt=90,cex=1.5)
gdf_PF_L = geomorph.data.frame(PF_gpa_L, species=Species_PF_L)
fit.shape_PF_L = procD.lm(coords ~ species, iter=999, turbo=TRUE, data=gdf_PF_L, print.progress=FALSE)
plotRefToTarget(fit.shape_PF_L$GM$fitted[,,1], fit.shape_PF_L$GM$fitted[,,1], method = c("points"), links = link_PF)
plotRefToTarget(fit.shape_PF_L$GM$fitted[,,6], fit.shape_PF_L$GM$fitted[,,6], method = c("points"), links = link_PF)
plotRefToTarget(fit.shape_PF_L$GM$fitted[,,8], fit.shape_PF_L$GM$fitted[,,8], method = c("points"), links = link_PF)
gdf_PF_S = geomorph.data.frame(PF_gpa_S, species=Species_PF_S)
fit.shape_PF_S = procD.lm(coords ~ species, iter=999, turbo=TRUE, data=gdf_PF_S, print.progress=FALSE)
plotRefToTarget(fit.shape_PF_S$GM$fitted[,,1], fit.shape_PF_S$GM$fitted[,,1], method = c("points"), links = link_PF)
plotRefToTarget(fit.shape_PF_S$GM$fitted[,,3], fit.shape_PF_S$GM$fitted[,,3], method = c("points"), links = link_PF)
plot(0,ylim=c(-0.5,0.5),xlim=c(-0.5,0.5),type='n',axes=FALSE,ann=FALSE)
text (0, 0, labels=c('Lateral\nsubterminal apophysis'),font=2,srt=90,cex=1.2)
gdf_PLA_L = geomorph.data.frame(PLA_gpa_L, species=Species_PLA_L)
fit.shape_PLA_L = procD.lm(coords ~ species, iter=999, turbo=TRUE, data=gdf_PLA_L, print.progress=FALSE)
plotRefToTarget(fit.shape_PLA_L$GM$fitted[,,1], fit.shape_PLA_L$GM$fitted[,,1], method = c("points"), links = link_PLA)
plotRefToTarget(fit.shape_PLA_L$GM$fitted[,,6], fit.shape_PLA_L$GM$fitted[,,6], method = c("points"), links = link_PLA)
plotRefToTarget(fit.shape_PLA_L$GM$fitted[,,8], fit.shape_PLA_L$GM$fitted[,,8], method = c("points"), links = link_PLA)
gdf_PLA_S = geomorph.data.frame(PLA_gpa_S, species=Species_PLA_S)
fit.shape_PLA_S = procD.lm(coords ~ species, iter=999, turbo=TRUE, data=gdf_PLA_S, print.progress=FALSE)
plotRefToTarget(fit.shape_PLA_S$GM$fitted[,,1], fit.shape_PLA_S$GM$fitted[,,1], method = c("points"), links = link_PLA)
plotRefToTarget(fit.shape_PLA_S$GM$fitted[,,3], fit.shape_PLA_S$GM$fitted[,,3], method = c("points"), links = link_PLA)